Index: code/branches/presentation2011/data/levels/spaceRace.oxw
===================================================================
--- code/branches/presentation2011/data/levels/spaceRace.oxw	(revision 8998)
+++ code/branches/presentation2011/data/levels/spaceRace.oxw	(revision 8999)
@@ -1,4 +1,4 @@
 <LevelInfo
- name = "Space Race"
+ name = "Old Space Race"
  description = "Have a furious Race in Space: Reach the checkpoints as fast as possible."
  tags = "gametype"
@@ -18,5 +18,5 @@
 
 <Level
- gametype = "SpaceRace"
+ gametype = "OldSpaceRace"
 >
   <templates>
@@ -52,17 +52,17 @@
     
     <!-- ------------------CheckPoints----------------- -->
-    <RaceCheckPoint name="checkpoint1" position="0,-2000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="false">
-        <attached>
-            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
-        </attached>
-        <collisionShapes>
-            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
-            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
-            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
-            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
-        </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint2" position="0,-900,2300" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false">
+    <OldRaceCheckPoint name="checkpoint1" position="0,-2000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="false">
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint2" position="0,-900,2300" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="1" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -96,7 +96,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint3" position="0,700,2700" stayActive="true" direction="0,0,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint3" position="0,700,2700" stayActive="true" direction="0,0,1" collisionType="static" scale="1" distance="40" checkpointindex="2" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -130,7 +130,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint4" position="0,2100,2300" stayActive="true" direction="0,1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint4" position="0,2100,2300" stayActive="true" direction="0,1,1" collisionType="static" scale="1" distance="40" checkpointindex="3" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -165,7 +165,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint5" position="0,2200,500" stayActive="true" direction="0,1,0" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint5" position="0,2200,500" stayActive="true" direction="0,1,0" collisionType="static" scale="1" distance="40" checkpointindex="4" islast="false">
         <attached>
         <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -200,7 +200,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint6" position="0,1500,-800" stayActive="true" direction="0,1,-1" collisionType="static" scale="1" distance="40" checkpointindex="5" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint6" position="0,1500,-800" stayActive="true" direction="0,1,-1" collisionType="static" scale="1" distance="40" checkpointindex="5" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -235,7 +235,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint7" position="0,200,-1900" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="6" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint7" position="0,200,-1900" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="6" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -270,7 +270,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint8" position="0,-700,-1400" stayActive="true" direction="0,-1,-1" collisionType="static" scale="1" distance="40" checkpointindex="7" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint8" position="0,-700,-1400" stayActive="true" direction="0,-1,-1" collisionType="static" scale="1" distance="40" checkpointindex="7" islast="false">
         <attached>
         <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -305,7 +305,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint9" position="0,-1300,-800" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="8" islast="false">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint9" position="0,-1300,-800" stayActive="true" collisionType="static" scale="1" distance="40" checkpointindex="8" islast="false">
         <attached>
             <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -331,7 +331,7 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
-
-    <RaceCheckPoint name="checkpoint10" position="0,-2100,0" collisionType="static" scale="1" distance="40" checkpointindex="9" islast="true" timelimit="150">
+    </OldRaceCheckPoint>
+
+    <OldRaceCheckPoint name="checkpoint10" position="0,-2100,0" collisionType="static" scale="1" distance="40" checkpointindex="9" islast="true" timelimit="150">
         <attached>
         <   Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
@@ -343,5 +343,5 @@
             <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
         </collisionShapes>
-    </RaceCheckPoint>
+    </OldRaceCheckPoint>
 
     <!-- ------------------Planet----------------- -->
Index: code/branches/presentation2011/src/modules/gametypes/CMakeLists.txt
===================================================================
--- code/branches/presentation2011/src/modules/gametypes/CMakeLists.txt	(revision 8998)
+++ code/branches/presentation2011/src/modules/gametypes/CMakeLists.txt	(revision 8999)
@@ -3,4 +3,6 @@
   RaceCheckPoint.cc
   SpaceRaceManager.cc
+  OldSpaceRace.cc
+  OldRaceCheckPoint.cc
 )
 
Index: code/branches/presentation2011/src/modules/gametypes/GametypesPrereqs.h
===================================================================
--- code/branches/presentation2011/src/modules/gametypes/GametypesPrereqs.h	(revision 8998)
+++ code/branches/presentation2011/src/modules/gametypes/GametypesPrereqs.h	(revision 8999)
@@ -66,4 +66,5 @@
 {
     class SpaceRace;
+    class OldSpaceRace;
 }
 
Index: code/branches/presentation2011/src/orxonox/controllers/FormationController.h
===================================================================
--- code/branches/presentation2011/src/orxonox/controllers/FormationController.h	(revision 8998)
+++ code/branches/presentation2011/src/orxonox/controllers/FormationController.h	(revision 8999)
@@ -77,6 +77,5 @@
 
       inline void setTeam(int team)
-           { this->team_ = team; 
-             orxout(debug_output) << "Set team to: "<<team<<" in "<<this<< endl;} 
+           { this->team_ = team; }
       inline int getTeam() const
            { return this->team_; }
@@ -87,7 +86,7 @@
                Defend-just defend the master
                Attack-leave formation, attack every target
-      */ 
+      */
       enum FormationMode {NORMAL,DEFEND,ATTACK};
-      
+
       /**
         @brief Sets the new mode. If master, set it for all slaves.
@@ -104,5 +103,5 @@
       int freedomCount_;
       enum State {SLAVE, MASTER, FREE};
-      
+
       State state_;
       std::vector<FormationController*> slaves_;
@@ -135,5 +134,5 @@
 
       void takeLeadOfFormation();
-      void masterAttacked(Pawn* originator);      
+      void masterAttacked(Pawn* originator);
 
       void specificMasterActionHold();
@@ -155,5 +154,5 @@
 
       static bool sameTeam(ControllableEntity* entity1, ControllableEntity* entity2, Gametype* gametype); // hack
-      
+
 
       void setTarget(Pawn* target);
@@ -162,5 +161,5 @@
 
       void targetDied();
-      
+
       bool bHasTargetPosition_;
       Vector3 targetPosition_;