Index: trunk/src/lib/util/executor/executor_lua.h
===================================================================
--- trunk/src/lib/util/executor/executor_lua.h	(revision 9003)
+++ trunk/src/lib/util/executor/executor_lua.h	(revision 9006)
@@ -44,9 +44,9 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua0(void(T::*function)())
-        : Executor()
+  : Executor()
     {
       this->functionPointer = function;
@@ -91,18 +91,18 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua1(void(T::*function)(type0))
-        : Executor(ExecutorParamType<type0>())
-    {
-      this->functionPointer = function;
-      this->functorType = Executor_Objective | Executor_NoLoadString;
-    }
-
-    /**
-       * @brief executes the Command on BaseObject
-       * @param object the BaseObject to execute this Executor on
-       * @param loadString ignored in this case
+  : Executor(ExecutorParamType<type0>())
+    {
+      this->functionPointer = function;
+      this->functorType = Executor_Objective | Executor_NoLoadString;
+    }
+
+    /**
+     * @brief executes the Command on BaseObject
+     * @param object the BaseObject to execute this Executor on
+     * @param loadString ignored in this case
      */
     virtual void operator()(BaseObject* object, const SubString& = SubString()) const
@@ -120,5 +120,5 @@
 
     /**
-       * @returns a _new_ Copy of this Executor
+     * @returns a _new_ Copy of this Executor
      */
     virtual Executor* clone () const
@@ -140,9 +140,9 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua2(void(T::*function)(type0, type1))
-        : Executor(ExecutorParamType<type0>(), ExecutorParamType<type1>())
+  : Executor(ExecutorParamType<type0>(), ExecutorParamType<type1>())
     {
       this->functionPointer = function;
@@ -166,6 +166,6 @@
 
       (dynamic_cast<T*>(object)->*(functionPointer))(
-        fromLua<type0>(state, 1),
-        fromLua<type1>(state, 2) );
+          fromLua<type0>(state, 1),
+      fromLua<type1>(state, 2) );
     }
 
@@ -217,6 +217,6 @@
       (dynamic_cast<T*>(object)->*(functionPointer))(
           fromLua<type0>(state, 1),
-          fromLua<type1>(state, 2),
-          fromLua<type2>(state, 3) );
+      fromLua<type1>(state, 2),
+      fromLua<type2>(state, 3) );
     }
 
@@ -268,7 +268,7 @@
       (dynamic_cast<T*>(object)->*(functionPointer))(
           fromLua<type0>(state, 1),
-          fromLua<type1>(state, 2),
-          fromLua<type2>(state, 3),
-          fromLua<type3>(state, 4) );
+      fromLua<type1>(state, 2),
+      fromLua<type2>(state, 3),
+      fromLua<type3>(state, 4) );
     }
 
@@ -300,9 +300,9 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua0ret(ret (T::*function)())
-        : Executor()
+  : Executor()
     {
       this->functionPointer = function;
@@ -329,5 +329,5 @@
 
     /**
-                       * @returns a _new_ Copy of this Executor
+     * @returns a _new_ Copy of this Executor
      */
     virtual Executor* clone () const
@@ -349,9 +349,9 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua1ret(ret (T::*function)(type0))
-        : Executor(ExecutorParamType<type0>())
+  : Executor(ExecutorParamType<type0>())
     {
       this->functionPointer = function;
@@ -375,5 +375,5 @@
 
       toLua<ret>(state, (dynamic_cast<T*>(object)->*(functionPointer))(
-                   fromLua<type0>(state, 1)));
+          fromLua<type0>(state, 1)));
     }
 
@@ -397,9 +397,9 @@
   public:
     /**
-     * @brief Constructor of a ExecutorXML
-     * @param function a Function to call
+   * @brief Constructor of a ExecutorXML
+   * @param function a Function to call
      */
     ExecutorLua2ret(ret (T::*function)(type0, type1))
-        : Executor(ExecutorParamType<type0>(), ExecutorParamType<type1>())
+  : Executor(ExecutorParamType<type0>(), ExecutorParamType<type1>())
     {
       this->functionPointer = function;
@@ -423,6 +423,6 @@
 
       toLua<ret>(state, (dynamic_cast<T*>(object)->*(functionPointer))(
-                   fromLua<type0>(state, 1),
-                   fromLua<type1>(state, 2) ));
+          fromLua<type0>(state, 1),
+          fromLua<type1>(state, 2) ));
     }
 
@@ -608,40 +608,40 @@
              ExecutorParamType<type2>(), ExecutorParamType<type3>(),
              ExecutorParamType<type4>(), ExecutorParamType<type5>())
-    {
-      this->functionPointer = function;
-      this->functorType = Executor_Objective | Executor_NoLoadString;
-    }
-
-    /**
-     * @brief executes the Command on BaseObject
-     * @param object the BaseObject to execute this Executor on
-     * @param loadString ignored in this case
-     */
-    virtual void operator()(BaseObject* object, const SubString& = SubString()) const
-    {
-      PRINTF(1)("no usefull executor\n");
-    }
-
-    virtual void operator()(BaseObject* object, int& count, void* values) const
-    {
-      lua_State* state = (lua_State*)values;
-      count = 1;
-
-      toLua<ret>(state, (dynamic_cast<T*>(object)->*(functionPointer))(
-          fromLua<type0>(state, 1),
-          fromLua<type1>(state, 2),
-          fromLua<type2>(state, 3),
-          fromLua<type3>(state, 4),
-          fromLua<type4>(state, 5),
-          fromLua<type5>(state, 6) ));
-    }
-
-    /**
-     * @returns a _new_ Copy of this Executor
-     */
-    virtual Executor* clone () const
-    {
-      return new ExecutorLua6ret<T, ret, type0, type1, type2, type3, type4, type5>(this->functionPointer);
-    }
+             {
+               this->functionPointer = function;
+               this->functorType = Executor_Objective | Executor_NoLoadString;
+             }
+
+    /**
+              * @brief executes the Command on BaseObject
+              * @param object the BaseObject to execute this Executor on
+              * @param loadString ignored in this case
+     */
+             virtual void operator()(BaseObject* object, const SubString& = SubString()) const
+             {
+               PRINTF(1)("no usefull executor\n");
+             }
+
+             virtual void operator()(BaseObject* object, int& count, void* values) const
+             {
+               lua_State* state = (lua_State*)values;
+               count = 1;
+
+               toLua<ret>(state, (dynamic_cast<T*>(object)->*(functionPointer))(
+                   fromLua<type0>(state, 1),
+                   fromLua<type1>(state, 2),
+                   fromLua<type2>(state, 3),
+                   fromLua<type3>(state, 4),
+                   fromLua<type4>(state, 5),
+                   fromLua<type5>(state, 6) ));
+             }
+
+    /**
+              * @returns a _new_ Copy of this Executor
+     */
+             virtual Executor* clone () const
+             {
+               return new ExecutorLua6ret<T, ret, type0, type1, type2, type3, type4, type5>(this->functionPointer);
+             }
   private:
     ret           (T::*functionPointer)(type0, type1, type2, type3, type4, type5);