Index: trunk/src/world_entities/elements/glgui_radar.cc
===================================================================
--- trunk/src/world_entities/elements/glgui_radar.cc	(revision 9014)
+++ trunk/src/world_entities/elements/glgui_radar.cc	(revision 9019)
@@ -42,5 +42,5 @@
     this->setBackgroundTexture("gui_radar.png");
 
-    this->_updateInterval = 1.0f;
+    this->_updateInterval = .01f;
     this->_timePassed = 0.0f;
     this->_range = 100.0f;
@@ -94,5 +94,5 @@
     _timePassed+=dt;
 
-    //if (_timePassed > _updateInterval)
+    if (_timePassed > _updateInterval)
     {
       _timePassed = 0 ; //-=_updateInterval;
Index: trunk/src/world_entities/environments/mapped_water.cc
===================================================================
--- trunk/src/world_entities/environments/mapped_water.cc	(revision 9014)
+++ trunk/src/world_entities/environments/mapped_water.cc	(revision 9019)
@@ -351,5 +351,5 @@
       OrxGui::GLGuiBox* waterColorBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* waterColorText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* waterColorText = new OrxGui::GLGuiText();
         waterColorText->setText("WaterColor");
         waterColorBox->pack(waterColorText);
@@ -380,5 +380,5 @@
       OrxGui::GLGuiBox* waterUVBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* waterUVText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* waterUVText = new OrxGui::GLGuiText();
         waterUVText->setText("WaterUV");
         waterUVBox->pack(waterUVText);
@@ -395,5 +395,5 @@
       OrxGui::GLGuiBox* waterFlowBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* waterFlowText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* waterFlowText = new OrxGui::GLGuiText();
         waterFlowText->setText("WaterFlow");
         waterFlowBox->pack(waterFlowText);
@@ -410,5 +410,5 @@
       OrxGui::GLGuiBox* shineSizeBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* shineSizeText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* shineSizeText = new OrxGui::GLGuiText();
         shineSizeText->setText("ShineSize");
         shineSizeBox->pack(shineSizeText);
@@ -425,5 +425,5 @@
       OrxGui::GLGuiBox* shineStrengthBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* shineStrengthText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* shineStrengthText = new OrxGui::GLGuiText();
         shineStrengthText->setText("ShineStrength");
         shineStrengthBox->pack(shineStrengthText);
@@ -440,5 +440,5 @@
       OrxGui::GLGuiBox* reflStrengthBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* reflStrengthText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* reflStrengthText = new OrxGui::GLGuiText();
         reflStrengthText->setText("ReflStrength");
         reflStrengthBox->pack(reflStrengthText);
@@ -455,5 +455,5 @@
       OrxGui::GLGuiBox* refractionBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* refractionText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* refractionText = new OrxGui::GLGuiText();
         refractionText->setText("Refraction");
         refractionBox->pack(refractionText);
@@ -470,5 +470,5 @@
       OrxGui::GLGuiBox* lightPosBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* lightPosText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* lightPosText = new OrxGui::GLGuiText();
         lightPosText->setText("LightPos");
         lightPosBox->pack(lightPosText);
@@ -499,5 +499,5 @@
       OrxGui::GLGuiBox* waterHeightBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
       {
-        OrxGui::GLGuiInputLine* waterHeightText = new OrxGui::GLGuiInputLine();
+        OrxGui::GLGuiText* waterHeightText = new OrxGui::GLGuiText();
         waterHeightText->setText("WaterHeight");
         waterHeightBox->pack(waterHeightText);
Index: trunk/src/world_entities/player.cc
===================================================================
--- trunk/src/world_entities/player.cc	(revision 9014)
+++ trunk/src/world_entities/player.cc	(revision 9019)
@@ -38,5 +38,5 @@
 
   this->playable = NULL;
-  this->hud.setVisibility(true);
+  this->_hud.setVisibility(true);
 
   this->subscribeEvent(ES_GAME, KeyMapper::PEV_CHANGE_SHIP);
@@ -62,6 +62,6 @@
   {
     PRINTF(4)("Player gets ejected from Playable\n");
-    this->hud.setEnergyWidget(NULL);
-    this->hud.setWeaponManager(NULL);
+    this->_hud.setEnergyWidget(NULL);
+    this->_hud.setWeaponManager(NULL);
 
     Playable* ejectedPlayable = this->playable;
@@ -75,6 +75,6 @@
     PRINTF(4)("Enter new Playable\n");
       this->playable = playable;
-      this->hud.setEnergyWidget(this->playable->getHealthWidget());
-      this->hud.setWeaponManager(&this->playable->getWeaponManager());
+      this->_hud.setEnergyWidget(this->playable->getHealthWidget());
+      this->_hud.setWeaponManager(&this->playable->getWeaponManager());
 
       this->playable->setPlayer(this);
@@ -96,5 +96,5 @@
  void Player::weaponConfigChanged()
  {
-   this->hud.updateWeaponManager();
+   this->_hud.updateWeaponManager();
  }
 
Index: trunk/src/world_entities/player.h
===================================================================
--- trunk/src/world_entities/player.h	(revision 9014)
+++ trunk/src/world_entities/player.h	(revision 9019)
@@ -32,6 +32,6 @@
     inline Playable*  getPlayable() const  { return this->playable; };
 
-//     inline Hud& hud() { return this->_hud; };
-//     inline const Hud& hud() const { return this->_hud; };
+     inline Hud& hud() { return this->_hud; };
+     inline const Hud& hud() const { return this->_hud; };
 
 
@@ -43,5 +43,5 @@
   private:
     Playable*         playable;                 //!< The one we controll or NULL if none
-    Hud               hud;                      //!< The HUD to be displayed for this Player.
+    Hud               _hud;                      //!< The HUD to be displayed for this Player.
 };
 