Index: /code/branches/pCuts/data/levels/presentationHS11.oxw
===================================================================
--- /code/branches/pCuts/data/levels/presentationHS11.oxw	(revision 9026)
+++ /code/branches/pCuts/data/levels/presentationHS11.oxw	(revision 9027)
@@ -1,2 +1,5 @@
+<!-- TODO: add in level documentation !! -->
+
+
 <LevelInfo
  name = "Presentation HS 2011"
@@ -79,4 +82,6 @@
         </events>
     </SimpleNotification>
+
+
 
 
@@ -131,9 +136,97 @@
 <?lua end ?>
 
-
-
-
-
-
+<!-- @Triggers: "hintX" <->  delayed LetsGo -->
+    <EventTrigger name="hint1" activations="1" stayactive="true" delay=4.2>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+    <EventTrigger name="hint2" activations="1" stayactive="true" delay=8.4>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+    <EventTrigger name="hint3" activations="1" stayactive="true" delay=12.6>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+    <EventTrigger name="hint4" activations="1" stayactive="true" delay=16.8>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+    <EventTrigger name="hint5" activations="1" stayactive="true" delay=21>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+    <EventTrigger name="hint6" activations="1" stayactive="true" delay=25.2>
+      <events>
+        <trigger>
+          <EventListener event="LetsGo" />
+        </trigger>
+      </events>
+    </EventTrigger>
+
+
+
+    <SimpleNotification message="Make bots follow you: Press (1)"  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint1 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Toggle group behaviour: Press (1)"  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint2 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Tell the bots to defend you: Press (2)"  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint3 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Make them attack opponents: Press (2)"  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint4 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Let the bots behave normal: Press (2) "  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint5 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Have a look at the console to verify this."  broadcast="true">
+        <events>
+            <trigger>
+                <EventListener event=hint6 />
+            </trigger>
+        </events>
+    </SimpleNotification>
 
 <!-- Generate asteroid field and asteroid belt -->
Index: /code/branches/pCuts/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- /code/branches/pCuts/src/orxonox/gametypes/Dynamicmatch.cc	(revision 9026)
+++ /code/branches/pCuts/src/orxonox/gametypes/Dynamicmatch.cc	(revision 9027)
@@ -31,16 +31,17 @@
 //Low; Codeoptimierung und Dokumentation
 
-/*
-short gaming manual:
-There are three different parties a player can belong to: victim, chaser or killer
-Every player starts as chaser. As long as there are not enough victims and killers, you can change your and other player's parties by shooting them.
-In order to win you have to earn as much points as possible:
-- as victim by escaping the chasers
-- as chaser by shooting the victim
-- as killer by killing the chasers
-
-
-What you shouldn't do is shooting at players of your own party. By doing so your score will decrease.
-P.S: If you don't want to be a victim: Get rid of your part by shooting a chaser.
+/**
+@brief
+    Short Gaming Manual:
+    There are three different parties a player can belong to: victim, chaser or killer
+    Every player starts as chaser. As long as there are not enough victims and killers, you can change your and other player's parties by shooting them.
+    In order to win you have to earn as much points as possible:
+    - as victim by escaping the chasers
+    - as chaser by shooting the victim
+    - as killer by killing the chasers
+
+
+    What you shouldn't do is shooting at players of your own party. By doing so your score will decrease.
+    P.S: If you don't want to be a victim: Get rid of your part by shooting a chaser.
 */
 #include "Dynamicmatch.h"
@@ -95,5 +96,4 @@
             ColourValue(0.3f, 0.3f, 1.0f),  //piggycolour
             ColourValue(0.3f, 1.0f, 0.3f)   //killercolour  what about black: 0.0f, 0.0f, 0.0f
-
         };
         static std::vector<ColourValue> defaultcolours(colours, colours + sizeof(colours) / sizeof(ColourValue));
@@ -111,6 +111,6 @@
         if (victim && victim->getPlayer()) //&& originator && originator->getPlayer() ??
         {
-        int target= playerParty_[victim->getPlayer()];
-        int source= playerParty_[originator->getPlayer()];
+            int target = playerParty_[victim->getPlayer()];
+            int source = playerParty_[originator->getPlayer()];
 
             //Case: Not Enough Pigs: party change (= party management)
@@ -309,5 +309,5 @@
     /**
     @brief
-        Grant the piggy a boost.
+        Grant the victim a boost.
     @param spaceship
         The SpaceShip to give the boost.
@@ -315,5 +315,5 @@
     void Dynamicmatch::grantPigBoost(SpaceShip* spaceship)
     {
-        // Give pig boost
+        // Give victim boost
         if (spaceship)
         {
@@ -374,9 +374,13 @@
 
         if (this->hasStarted() && !gameEnded_)
-        {   pointsPerTime =pointsPerTime + dt;
-            gameTime_ = gameTime_ - dt;
-            if (pointsPerTime > 2.0f)//hard coded!! should be changed
-            {
-                pointsPerTime=0.0f;
+        {
+orxout() << " number of chasers:  " << numberOf[chaser] << endl;
+orxout() << " number of killers:  " << numberOf[killer] << endl;
+orxout() << " number of victims:  " << numberOf[piggy] << endl;
+            pointsPerTime = pointsPerTime + dt; //increase points
+            gameTime_ = gameTime_ - dt; // decrease game time
+            if (pointsPerTime > 2.0f) //hard coded points for victim! should be changed
+            {
+                pointsPerTime = 0.0f;
                 rewardPig();
             }
@@ -408,4 +412,7 @@
     }
 
+/**
+    @brief The reward function is called every 2 seconds via the tick function and makes the victim score points.
+*/
     void Dynamicmatch::rewardPig()
     {
@@ -415,5 +422,5 @@
             {
                  //Spieler mit der Pig-party frags++
-                 std::map<PlayerInfo*, Player>::iterator it2 = this->players_.find(it->first);// still not sure if right syntax
+                 std::map<PlayerInfo*, Player>::iterator it2 = this->players_.find(it->first);
                  if (it2 != this->players_.end())
                  {
Index: /code/branches/pCuts/src/orxonox/gametypes/TeamDeathmatch.cc
===================================================================
--- /code/branches/pCuts/src/orxonox/gametypes/TeamDeathmatch.cc	(revision 9026)
+++ /code/branches/pCuts/src/orxonox/gametypes/TeamDeathmatch.cc	(revision 9027)
@@ -30,9 +30,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/ConfigValueIncludes.h"
 #include "chat/ChatManager.h"
-#include "interfaces/TeamColourable.h"
 #include "infos/PlayerInfo.h"
-#include "worldentities/TeamSpawnPoint.h"
 #include "worldentities/pawns/Pawn.h"
 
Index: /code/branches/pCuts/src/orxonox/gametypes/TeamGametype.cc
===================================================================
--- /code/branches/pCuts/src/orxonox/gametypes/TeamGametype.cc	(revision 9026)
+++ /code/branches/pCuts/src/orxonox/gametypes/TeamGametype.cc	(revision 9027)
@@ -89,4 +89,9 @@
     }
 
+    /**
+    @brief
+        Function that determines the player's team number when entering the game for the first time.
+        Override this function for other team structures.
+    */
     void TeamGametype::findAndSetTeam(PlayerInfo* player)
     {
@@ -130,5 +135,4 @@
             this->allowedInGame_.erase(player);
         }
-
 
         return valid_player;